/*
   Some key/scan codes.
   -- by Benny, '96.
   Two unsigned char's: scan|key.
   TC/WC/GC
   v1.2.3
   key shortcut:   if (!key) key = scan;
*/

#ifndef _KEYCODES_H
#define _KEYCODES_H

/* KEY: */
#define TAB	9
#define ESCAPE  0x1B
#define LEFT    0x4B
#define RIGHT   0x4D
#define UP      0x48
#define DOWN    0x50
#define END     0x4F
#define HOME    0x47
#define PGUP    0x49
#define PGDN    0x51
#define INS     0x52  /* can't repeat   */
#define DEL     0x53  /* inop too       */
#define ENTER   0x0D  /* as key, 0x1C as scan */

#define PLUS	'+'
#define MINUS	'-'
#define SPACE	' '

#define BS      0x08
#define BACK    0x08
#define BACKSPACE    0x08

#define CONSOLE		0xFD


/* SCAN: (KEY is 0 or 1 or ...) */
#define BACKSCAN   	0x0E
#define ESCAPESCAN   	1
#define F1      0x3B
#define F2      0x3C
#define F3      0x3D
#define F4      0x3E
#define F5      0x3F
#define F6      0x40
#define F7      0x41
#define F8      0x42
#define F9      0x43
#define F10     0x44
/*...*/
#define SHIFTF1      0x54 // F1+25
/*...*/
#define SHIFTF10     0x5D
#define CTRLF1       0x5E
/*...*/
#define CTRLF10      0x67

#define CTRLPGUP     0x84
#define CTRLPGDN     0x76
#define CTRLHOME     0x77
#define CTRLEND      0x75

#endif /* _KEYCODES_H */
