#define VERSION "1.0" // public version
/*
  LISTy (internal version: 2.7.2 beta)
   a simplified LIST clone with Win95/Dos7 LFN modes
   for TurboC 3.0
   by Benny <benny_land@geocities.com>

  Todo:
   - page flipping/block move (for top/end lines)
   - two columns

  Bugs:
  - plain DOS LFN names retrieval doesn't work on FAT32 drives.
  - dynamic allocation so-so (doesn't free used, only all)
  - Doesn't look into path for LIST.COM
  - doesn't show hidden files (fixed?)
  - when return from shell, killed if lfn too long.
  - can't see lfn names with spaces.
  - when returning from shell, the program is killed by Win9x
   if the lfn name was too long (extending beyond the right margin.)
  - can't shell to lfn names with spaces.
  - sort is not perfect on some dirs (scrambled at places)
  - doesn't update dir if files were deleted
*/
#include "linclude.h"

//#define DEBUG
//#define DEBUG0
//#define DEBUG1
//#define NOSORT
//#define LISTVERSION
#define SHOWCOLORS
#define FILES_MAX	   3000

#define PROGRAM0           "EDIT.BAT"
#define PROGRAM1           "CUBIX.BAT"
#define PROGRAM2           "FV.COM"     // FileView by V.Buerg
#define PROGRAM3           "ZV.COM"     // ZipView by G.Haff

#define PROGRAM4           "WPNG.BAT"
#define DELTREE		   "DELTREE" //  /Y"

//--------------------------------
#define TEXTLOCATION	0xB8000000
#define BYDATE 		0
#define BYNAME 		1
#define BYEXT 		2
#define BYSIZE 		3

extern unsigned _stklen = 64000U;

#define TOPCOLOR   	{textcolor(BLACK);   	textbackground(LIGHTGRAY);}
#define BODYCOLOR   	{textcolor(LIGHTCYAN);   textbackground(BLUE);}
#define RESETCOLOR   	textattr(7);

#define UPMARK          24
#define DOWNMARK        25

#ifdef USEBIT
#define TOPBIT		0x80000000	// 10000000 00000000 00000000 00000000
//#define DOWNBIT       0xC0000000      // 11000000 00000000 00000000 00000000
#define UPBIT		0x40000000	// 01000000 00000000 00000000 00000000
#define UPBITMASK	0x5FFFFFFF	// 01011111 11111111 11111111 11111111
#define DOWNBIT		0x60000000	// 01100000 00000000 00000000 00000000
#define BITMASK		0x7FFFFFFF	// 01111111 11111111 11111111 11111111
#endif

#define UPDIR 		"<DIR>"
#define DOWNDIR 	UPDIR

#define SAME 		0

#define NOCURSOR    	_setcursortype(_NOCURSOR)
#define CURSOR     	_setcursortype(_NORMALCURSOR)

void            DrawLine(int, int, int, int);
void            error(char *t);

#define LASTLINE  	41

struct LINE {
    char            filename[8];
    char            fileext[4];
    char            f_0;
    char            filesize[10];
    char            f_1;
    char            filedate[8];
    char            f_2;
    char            filetime[5];
    char            f_4;
    char            fileLFN[LASTLINE];
};

#define NAMESIZE	14
#define LFNSIZE		260
struct FindData {
    ulong           attrib;	// dword

    ulong           creat_time[2];	// qword
    ulong           access_time[2];	// qword

    ulong           datime;
    ushort          date;
    ushort          time;

    ulong           sizehi;	// qword
    ulong           size;

    char            reserved[8];	// 8
    char            LFN[LFNSIZE];	// 260
    char            name[NAMESIZE];	// 14

};

struct FILEBLOCK {		// 1 + 4 + 8+1+3 = 5 + 12 = 17
    uchar           dir;
    ulong           key;
    char            name[NAMESIZE];	// found file name
    long            size;	// file size
    ushort          date;	// file date
    ushort          time;	// file time
    char            attrib;	// attribute found
    char            LFN[LASTLINE];
    char            ext[3];
    ushort	    day, month, year;
    ushort	    hour, min;
};

#define OVERFLOWCHECK

FILEBLOCK     **logged;
short           ctl = 0;	// max 32,767

long            loggedmax = -1;

static int      FileHandle;
char            SortType = BYEXT; //BYNAME;

char            fileoverflow = ' ';
char            drivedata[30] = " ";
char            line[25][130];
ulong           totalsize;
char            startdir[MAXPATH];
char            curdir[MAXPATH];
char            lastdir[MAXPATH] ={0};
int             lastdirflag = 0;
int             startdrive, curdrive;
char            Selection[100];
char            filemask[NAMESIZE] = "*.*";	// get it from argv[x]

int             RestoreScreen = YES;
char            FlagTopDir = 0;

char            iswin95 = NO;
char            usedos = YES, usedoslfn = NO;

char            FlagAttr = NO;
int             oldcursx, oldcursy;
short           sizemode = 0;

short           lone_dot_flag = 0;

#define UNICODE 	0
#define MSCODE 		1
#define UNIMODE		MSCODE
//#define UNIMODE               UNICODE

#include "lfndir2.cpp"

//--------------------------------------------------------

int             LFNFindClose();

// TurboC asm

#define FINDFIRST       asm {            \
		push	ds;              \
		mov     ax, 0x714E;      \
		mov	cx, attrib;      \
		mov	si, UNIMODE;     \
		lds	dx, pathname;    \
		les	di, ffblk;       \
		int	0x21;            \
		pop	ds;              \
	jc      donefirst;               \
	}
#define FINDNEXT	asm {            \
		push	ds;              \
		mov 	ax, 0x714F;      \
		mov	bx, FileHandle;  \
		mov	si, UNIMODE;     \
		les	di, ffblk;       \
		int	0x21;            \
		pop	ds;              \
	jc      donenext;                \
	}
#define FINDCLOSE	asm {		 \
		push	ds;              \
		mov 	ax, 0x71A1;      \
		mov	bx, FileHandle;  \
		int	0x21;            \
		pop	ds;              \
	jc      doneclose;               \
	}

int             LFNFindFirst(char *pathname, FindData * ffblk, int attrib)
{
    FileHandle = 0;
    FINDFIRST;
    FileHandle = _AX;
    return 0;
  donefirst:
    return 1;
}

int             LFNFindNext(FindData * ffblk)
{
    FINDNEXT;
    return 0;
  donenext:
    LFNFindClose();
    return 1;
}

int             LFNFindClose()
{
    FINDCLOSE;
    return 0;
  doneclose:
    return 1;
}

//---------

char           *current_directory(char *path)
{
    if (strcmp(curdir, lastdir) != 0)
	strcpy(lastdir, curdir);

    strcpy(path, "X:\\");
    path[0] = 'A' + getdisk();
    getcurdir(0, path + 3);
#ifdef DEBUG0
    printf("realnewdir= '%s'\n",path);
#endif

    return (path);
}

#ifdef DEBUG
int ctv = 0;
#define DEBUGCTV printf("ctv = %i, ",ctv++);
#else
#define DEBUGCTV
#endif

short           GetLFNdrive()
{
    char            direc[132];
    short           retval;
    ushort          driv;

    DEBUGCTV;
    lone_dot_flag = 0;
    ctl = -1;
    totalsize = 0;
    FlagTopDir = NO;

    current_directory(curdir);
    DEBUGCTV;

    if (curdir[1] == ':') {
	driv = tolower(curdir[0]) - 'a';
	strcpy(direc, curdir);
    } else {
	sprintf(direc, "Couldn't get current dir = '%s'\n", curdir);
	error(direc);
    }

#if 1
    driv = driv;
    DEBUGCTV;
#ifdef DEBUG0
    printf("curdir = '%s'\n",curdir);
#endif
    if (lfndir(curdir)==FAILED)
	error("*** FAILED ***");
    DEBUGCTV;
#endif

    fileoverflow = ' ';
    if (curdir[3] == 0)
	FlagTopDir = YES;

    DEBUGCTV;
    return 0;
}

void            Get95drive()
{
    ffblk           fblock;
    FindData        LFNblock;
    int             done, LFNdone;

    totalsize = 0;
    current_directory(curdir);

    ctl = -1;
    fileoverflow = ' ';
    FlagTopDir = NO;

    if (iswin95)
	LFNdone = LFNFindFirst(filemask, &LFNblock,
		    FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC | FA_ARCH);
    done = findfirst(filemask, &fblock,
		     FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC | FA_ARCH);
    while (!done) {
	if (fblock.ff_attrib & FA_LABEL)
	    continue;
	ctl++;
#ifdef OVERFLOWCHECK
	if (ctl >= FILES_MAX) {
	    ctl--;
	    fileoverflow = '+';
	    return;
	}
#endif

	if (strcmp(fblock.ff_name, ".") == SAME)
	    ctl--;
	else {
	    if (ctl > loggedmax) {
		logged[ctl] = new FILEBLOCK;
		if (!logged[ctl]) {
		    ctl--;
		    fileoverflow = '+';
		    return;
		}
		loggedmax++;
	    }
	    totalsize += fblock.ff_fsize;

	    logged[ctl]->dir = 0x20;

	    logged[ctl]->size = fblock.ff_fsize;
	    logged[ctl]->date = fblock.ff_fdate;
	    logged[ctl]->time = fblock.ff_ftime;
	    logged[ctl]->attrib = fblock.ff_attrib;

	    if (iswin95) {
		if (LFNblock.name[0] == 0)
		    LFNblock.LFN[0] = 0;
		memcpy(&logged[ctl]->LFN, &LFNblock.LFN, LASTLINE);
	    } else
		logged[ctl]->LFN[0] = 0;
            if (strncmp(fblock.ff_name, "..", 2) == SAME) { //(Benny)
		sprintf(logged[ctl]->name, "%c%s", UPMARK,
			fblock.ff_name);
		FlagTopDir = YES;
		logged[ctl]->dir = UPMARK;
		logged[ctl]->ext[0] = logged[ctl]->ext[1] =
		    logged[ctl]->ext[2] = UPMARK;
	    } else if (fblock.ff_attrib & FA_DIREC) {
		sprintf(logged[ctl]->name, "%c%s", DOWNMARK,
			fblock.ff_name);
		logged[ctl]->dir = DOWNMARK;
		logged[ctl]->ext[0] = logged[ctl]->ext[1] =
		    logged[ctl]->ext[2] = DOWNMARK;
	    } else {
		memcpy(&logged[ctl]->name, &fblock.ff_name, sizeof(fblock.ff_name));
		char           *dot = strchr(fblock.ff_name, '.');
		if (dot)
		    memcpy(logged[ctl]->ext, dot + 1, 3);
		else
		    memset(logged[ctl]->ext, 0, 3);
	    }
	    logged[ctl]->key = 0;
	    if (SortType == BYEXT)
		memcpy(&logged[ctl]->key, &logged[ctl]->ext, 3);
	    else if (SortType == BYDATE) {
		logged[ctl]->key = (ulong)
			logged[ctl]->date << 16 + logged[ctl]->time;
	    } else if (SortType == BYSIZE)
		logged[ctl]->key = logged[ctl]->size;
#ifdef USEBIT
	    logged[ctl]->key &= BITMASK;
	    if (logged[ctl]->dir == UPMARK) {
		logged[ctl]->key |= UPBIT;
		logged[ctl]->key &= UPBITMASK;
	    } else if (logged[ctl]->dir == DOWNMARK)
		logged[ctl]->key |= DOWNBIT;
	    else
		logged[ctl]->key |= TOPBIT;
#endif
	}
	if (iswin95)
	    if (!LFNdone)
		LFNdone = LFNFindNext(&LFNblock);

	done = findnext(&fblock);
    }
}

//====================================================================
void            error(char *t)
{
    printf("=== Error: %s\n", t);
    printf("=== Free mem = %lu\n", coreleft());
    CURSOR;
    exit(1);
}


void            memsetline()
{
    int             j;
    for (j = 0; j < 25; j++)
	memset(line[j], 0x20, 80);
}

#define PADMODELEFT	"%-80s"
#define PADMODELEFT2	"%-79s"
#define PADMODERIGHT	"%80s"

#ifdef SHOWCOLORS
void            ShowScreen()
{
    int             j;

    gotoxy(1, 1);
    TOPCOLOR;
    cprintf(PADMODELEFT, line[0]);
    BODYCOLOR;
    for (j = 1; j < 24; j++)
	cprintf(PADMODERIGHT, line[j]);
    TOPCOLOR;
    *((char *) TEXTLOCATION + 4000 - 1) = (LIGHTGRAY << 4);
    cprintf(PADMODELEFT2, line[24]);
    gotoxy(9, 25);
    DrawLine(2, 0, BLACK, WHITE);
}
#else
void            ShowScreen()
{
    gotoxy(1, 1);
    cprintf(PADMODELEFT, line[0]);
    for (int j = 1; j < 24; j++)
	cprintf(PADMODERIGHT, line[j]);
    cprintf(PADMODELEFT2, line[24]);
    gotoxy(9, 25);
}
#endif

int             Sys_DetectWin95()
{
    union REGS      r;
    r.x.ax = 0x160a;		/* Get Windows Version */
    int86(0x2f, &r, &r);
    if (r.x.ax || r.h.bh < 4)	/* Not windows or earlier than Win95 */
	return NO;
    return YES;
}

void            GetDiskFreeSpace()
{
    struct dfree    free;
    long            avail;
    int             drive;

    drive = getdisk();
    getdfree(drive + 1, &free);
    if (free.df_sclus == 0xFFFF) {
	sprintf(drivedata, "Free:????");
	return;
    }
    avail = (long) free.df_avail
	* (long) free.df_bsec
	* (long) free.df_sclus;
    sprintf(drivedata, "Free:%ldm", (avail >> 20));
}

void            CallCommand(char *commande, char *param)
{
    char           *CommandPath, tampcommand[130];

    CommandPath = getenv("COMSPEC");
    strcpy(tampcommand, CommandPath);
    strcat(tampcommand, " /C ");
    strcat(tampcommand, commande);
    strcat(tampcommand, " ");
    strcat(tampcommand, param);

#ifdef DEBUG1
    printf("\ncommand = '%s'\n", tampcommand);
#endif
    system(tampcommand);
}

void            CallCommands(char *commande, char *param1, char *param2)
{
    char           *CommandPath, tampcommand[132];
    CommandPath = getenv("COMSPEC");
    sprintf(tampcommand, "%s /C %s %s %s", CommandPath, commande, param1, param2);
//    printf("\n'%s'",tampcommand);    getch();
    system(tampcommand);
}

#define SORTLEN		17
void            quick(int left, int right)
{
    int             i, j, k, x;
    FILEBLOCK      *temp;

    if (left < right) {
	if (memcmp(logged[left], logged[right], SORTLEN) > 0) {
	    temp = logged[left];
	    logged[left] = logged[right];
	    logged[right] = temp;
	}
	j = left;
	k = right;
	do {
	    do {
		j++;
	    } while (memcmp(logged[j], logged[left], SORTLEN) < 0);
	    do {
		k--;
	    } while (memcmp(logged[k], logged[left], SORTLEN) > 0);
	    if (j < k) {
		temp = logged[j];
		logged[j] = logged[k];
		logged[k] = temp;
	    }
	} while (j <= k);

	temp = logged[left];
	logged[left] = logged[k];
	logged[k] = temp;

	quick(left, k - 1);
	quick(k + 1, right);
    }
}

void            quickkey(int left, int right)
{
    int             i, j, k, x;
    FILEBLOCK      *temp;

    if (left < right) {
	if (logged[left]->key > logged[right]->key) {
	    temp = logged[left];
	    logged[left] = logged[right];
	    logged[right] = temp;
	}
	j = left;
	k = right;
	do {
	    do {
		j++;
	    } while (logged[j]->key < logged[left]->key);
	    do {
		k--;
	    } while (logged[k]->key > logged[left]->key);
	    if (j < k) {
		temp = logged[j];
		logged[j] = logged[k];
		logged[k] = temp;
	    }
	} while (j <= k);
	temp = logged[left];
	logged[left] = logged[k];
	logged[k] = temp;

	quickkey(left, k - 1);
	quickkey(k + 1, right);
    }
}

void            SortList()
{
    switch (SortType) {
    case BYNAME:
    case BYEXT:
	quick(0, ctl);
	break;
    case BYSIZE:
    case BYDATE:
	quickkey(0, ctl);
	break;
    }
}

void            Reshuffle(char switcher)
{
    int             j;
    switch (switcher) {
    case BYDATE:
	for (j = 0; j < ctl + 1; j++) {
	    logged[j]->key = (((ulong)
		logged[j]->date) << 16) + logged[j]->time;
#ifdef USEBIT
	    logged[j]->key &= BITMASK;
	    if (logged[j]->dir == UPMARK) {
		logged[j]->key |= UPBIT;
		logged[j]->key &= UPBITMASK;
	    } else if (logged[j]->dir == DOWNMARK)
		logged[j]->key |= DOWNBIT;
	    else
		logged[ctl]->key |= TOPBIT;
#endif
	}
	break;
    case BYNAME:
	for (j = 0; j < ctl + 1; j++) {
	    logged[j]->key = 0;
	}
	break;
    case BYEXT:
	for (j = 0; j < ctl + 1; j++) {
	    logged[j]->key = 0;
	    memcpy((char *) &logged[j]->key, (char *) &logged[j]->ext, 3);
	}
	break;
    case BYSIZE:
	for (j = 0; j < ctl + 1; j++)
	    logged[j]->key = logged[j]->size;
#ifdef USEBIT
	logged[j]->key &= BITMASK;
	if (logged[j]->dir == UPMARK) {
	    logged[j]->key |= UPBIT;
	    logged[j]->key &= UPBITMASK;
	} else if (logged[j]->dir == DOWNMARK)
	    logged[j]->key |= DOWNBIT;
	else
	    logged[ctl]->key |= TOPBIT;
#endif
    }
}

void            FillList(int startline)
{
    int             j, k, j1;
    struct LINE     Line;
    unsigned char   jour, heures, annee;
    unsigned        minutes, mois;
    unsigned        hilo;
    unsigned char   hi, lo;
    char            fsizes[20];
    char            three[8];
    char           *thee;
    char            ashr[5];
    char            Linekey[9];

    if (startline >= ctl + 1)
	return;
    memsetline();

    j1 = 0;
    for (j = startline; j < ctl + 1; j++) {
	if (j > startline + 23)
	    break;
	j1++;

	memset(&Line, 0x20, 80);

	sprintf(Line.filename, "%s", logged[j]->name);
	if (logged[j]->name[0] == UPMARK)
	    sprintf(Line.filesize, UPDIR);
	else if (logged[j]->name[0] == DOWNMARK)
	    sprintf(Line.filesize, DOWNDIR);
	else
	    sprintf(Line.filesize, "%10li", logged[j]->size);

	if (sizemode) {
	    sprintf(Line.filedate, "    %.4X", logged[j]->date);
	    sprintf(Line.filetime, "%.5X", logged[j]->time);
	} else if (usedoslfn) {
	    sprintf(Line.filedate, "%.2u/%.2u/%.2u", logged[j]->day, logged[j]->month, logged[j]->year);
	    sprintf(Line.filetime, "%.2u:%.2u", logged[j]->hour, logged[j]->min);
	} else {
	    hilo = logged[j]->date;
	    hi = hilo >> 8;
	    lo = (hilo & 0xFF);
	    jour = lo;
	    mois = hilo;
	    annee = hi;
	    mois <<= 7;
	    mois >>= 12;
	    jour <<= 3;
	    jour >>= 3;
	    annee >>= 1;
	    annee += 80;
	    if (annee > 99)
		annee -= 100;	// for year 2000

	    hilo = logged[j]->time;
	    hi = hilo >> 8;
	    heures = hi;
	    minutes = hilo;
	    heures >>= 3;
	    minutes <<= 5;
	    minutes >>= 10;

	    sprintf(Line.filedate, "%.2u/%.2u/%.2u", jour, mois, annee);
	    sprintf(Line.filetime, "%.2u:%.2u", heures, minutes);
	}
#ifdef SHOWKEY
	if (SortType == BYEXT) {
	    thee = (char *) &logged[j]->key;
	    sprintf(Linekey, "  %c%c%c   ", thee[0], thee[1], thee[2]);
	} else
	    sprintf(Linekey, "%.8lX", logged[j]->key);
#endif
	if (FlagAttr) {
	    if (logged[j]->attrib & FA_ARCH)
		ashr[0] = 'A';
	    else
		ashr[0] = '-';
	    if (logged[j]->attrib & FA_SYSTEM)
		ashr[1] = 'S';
	    else
		ashr[1] = '-';
	    if (logged[j]->attrib & FA_HIDDEN)
		ashr[2] = 'H';
	    else
		ashr[2] = '-';
	    if (logged[j]->attrib & FA_RDONLY)
		ashr[3] = 'R';
	    else
		ashr[3] = '-';

//              sprintf(Line.fileLFN,"%.4s %.9s %.36s",ashr,Linekey,logged[j]->LFN);
	    sprintf(Line.fileLFN, "%.4s %.36s", ashr, logged[j]->LFN);
	} else {
//              sprintf(Line.fileLFN,"%.9s %.32s",Linekey, logged[j]->LFN);
	    sprintf(Line.fileLFN, "%.41s", logged[j]->LFN);
	}

	memcpy(line[j1], &Line, 80);
	for (k = 0; k < 80; k++)
	    if (line[j1][k] == 0)
		line[j1][k] = 0x20;
    }

    if (totalsize < 0x100000)
	sprintf(fsizes, "%luk", totalsize >> 10);
    else
	sprintf(fsizes, "%lum", totalsize >> 20);

    sprintf(line[24],
	    "Command:                            "
	    "          Files:%i%c Used:%s%c %s"
	    ,ctl + 1
	    ,fileoverflow
	    ,fsizes
	    ,fileoverflow
	    ,drivedata
	);

}

void            GetCurrentDirData()
{
    if (iswin95 || usedos) {
	Get95drive();
	return;
    }
    if (!iswin95) GetLFNdrive();
}

void            DrawLine(int line, int xpos, int back, int front)
{
    int             j, k;
    int             LineWidth = 38;

    if (line < 1 || line > 25)	return;
    for (j = 0; j < LineWidth; j++) {
	k = 80 * (line - 1) * 2 + 1 + j * 2 + xpos;
	*((char *) TEXTLOCATION + k) = (back << 4) + front;
    }
}

char           *UpdatePosition(int filenumber)
{
    char           *ptr;

    ptr = logged[filenumber]->name;
    gotoxy(1, 1);
    if (logged[filenumber]->name[0] == UPMARK)
	ptr++;
    else if (logged[filenumber]->name[0] == DOWNMARK)
	ptr++;

    if (curdir[3] == 0)		// 'X:\'
	sprintf(Selection, "%s%s", curdir, ptr);
    else
	sprintf(Selection, "%s\\%s", curdir, ptr);
    cprintf("%s             ", Selection);
    gotoxy(9, 25);
    return ptr;
}

void            FreeSpace()
{
    int             j;
    for (j = 0; j <= loggedmax; j++)
	delete          logged[j];

    loggedmax = -1;
}

#define REDRAW  DrawLine(2, 0, BLUE, LIGHTCYAN);		\
		DrawLine(last_ypos, 0, BLUE, LIGHTCYAN);	\
		DrawLine(ypos, 0, BLACK, WHITE);		\
		last_ypos = ypos;

#define INDEX   	start+ypos-2
/*
   Where the aux routines are:
*/
char listpath[130] = {"d:\\specials\\"};
char call_list[130];

#define REFRESH         ShowScreen();

void            GetSpecialsPath()
{
    char           *WhereListIs = 0;
    WhereListIs = getenv("LISTY");
    if (WhereListIs) {
	size_t len;
	len = strlen(WhereListIs);
	if (!len) return;
	len--;
	if (WhereListIs[len]!='\\')
		sprintf(listpath, "%s\\", WhereListIs);
	else
		sprintf(listpath, "%s", WhereListIs);
	}
}

#include "gethekey.h"
#define	GETINPUT	checkkey();	//getkey();

//#define GETS	blineflag=gets(bline)
//#define GETS	blineflag=cscanf("%80s", bline)
//#define GETS	blineflag=scanf("%80s", bline)
#define GETS	blineflag=buffered_input(bline)

uchar bline2[80];
uchar buffered_input(char *bline)
{
 uchar blineflag, *bliner;

	asm push ds
	asm pusha
	bline2[0] = 80;
	asm mov dx,offset bline2;
	asm mov ax,seg bline2;
	asm mov ds,ax
	asm mov ah, 0x0A;
	asm int 0x21;
	asm popa
	asm pop ds

	bliner = bline2;
	blineflag = bliner[1];
	bliner += 2;
	bliner[blineflag] = 0;
	memcpy(bline, bliner, blineflag+1);
	return blineflag;
}

#define BLINE	{CURSOR; GETS; REFRESH; NOCURSOR;}

#define logname 	bline
#define NONE		-1
void            MainRoutine()
{
    int             ypos = 2, last_ypos = 2, lastypos = 2;
    int             start = 0, laststart = 0;
    char            oldSortType = NONE;
    int             j;
    char            bline[80] = "";
    int             blineval;
    int             tmpdrive;
    int             hit = 1;
    struct time     t;
    char            blinker;
//    char	    *
    int		    blineflag;

    if (getenv("windir"))
	iswin95 = YES;
    else if (Sys_DetectWin95())
	iswin95 = YES;
    else
	iswin95 = NO;

    logged = new FILEBLOCK *[FILES_MAX];
    if (!logged)
	error("no mem for logging files");

    cprintf("Wait...\n\r");

  FullStart:;
    start = 0;
    ypos = 2;
  ReStart:;
    oldSortType = NONE; // added June 1, 98.
    NOCURSOR;
    gotoxy(1, 1);
    cprintf("Wait...                  ");
    GetDiskFreeSpace();
    GetCurrentDirData();
  ReSort:;
    if (oldSortType != SortType) {
	Reshuffle(SortType);
	oldSortType = SortType;
    }
#ifndef NOSORT
    SortList();
#endif
  NextPage:;
    FillList(start);
  ShowScr:;
    ShowScreen();

    if (INDEX > ctl) {
	ypos = ctl - 2 - start;
    }
    hit = 1;
    if (ypos < 2) {
	ypos = 2;
    }
    if (start > ctl) {
	start = ctl;
    }
    while (1) {
	if (hit) {
	    if (ypos < 2) {
		ypos = 2;
	    }
	    if (start > ctl) {
		start = ctl;
	    }
	    UpdatePosition(INDEX);
	    gotoxy(67, 1);
	    if (iswin95)
		cprintf("W95 ");
	    else if (usedos)
		cprintf("DOS ");
	    else if (usedoslfn)
                cprintf("lfn "); // (Benny)
	    else
		cprintf("??? ");
	    cprintf("%luk", coreleft() >> 10);

	    gotoxy(9, 25);
	    REDRAW
	    gotoxy(1, 25);

	}
	gettime(&t);
	if (t.ti_sec == (t.ti_sec | 1))		// not even
	    blinker = ':';
	else
	    blinker = ' ';
	gotoxy(80 - 4, 1);
	cprintf("%.2d%c%.2d", t.ti_hour, blinker, t.ti_min);
	gotoxy(1, 25);

	GETINPUT;

	if (key == 0x1b)
	return;

	hit = 1;
	switch (key) {
	case 'x':
	case 'X':
	    strcpy(startdir, curdir);
	    RestoreScreen = NO;
	    startdrive = curdrive;
	    return;
	case ENTER:
	    if (logged[INDEX]->attrib & FA_DIREC) {
		char *ptr;
		if (lastdir)
		    if ((ptr=strstr(Selection, ".."))!=0) {
			start = laststart;
			ypos = lastypos;
			ptr[2] = 0;
			chdir(Selection);
#ifdef DEBUG0
			printf("selection= '%s'\n",Selection);
#endif
			goto ReStart;
		    }
		laststart = start;
		lastypos = ypos;
		if ((ptr=strchr(Selection, ' '))!=0) //new
			ptr[0] = 0;
		chdir(Selection);
#ifdef DEBUG0
		printf("Selection= '%s'\n",Selection);
#endif
		goto FullStart;
	    }
	    cprintf("spawn %s       ", logged[INDEX]->name);
	    CURSOR;
	    sprintf(call_list,"%s%s", listpath, "LIST.COM ");
            spawnl(P_WAIT, call_list, call_list, logged[INDEX]->name, NULL);
	    NOCURSOR;
	    goto NextPage;
	case 'c':
	case 'C':
	    cprintf("Copy %s to? ", logged[INDEX]->name);
	    BLINE;
	    if (blineflag) {
		cprintf("Copy %s to %s ", logged[INDEX]->name, bline);
		CallCommands("COPY", logged[INDEX]->name, bline);
		goto ReStart;
		}
	    break;
	// Buerg's style
#ifdef LISTVERSION
	case 'p':
	case 'P':
#else
	case 'o':
	case 'O':
#endif
	    cprintf("Drive? ");
	    BLINE;
	    if (blineflag) {
		char twobytes[2];
		twobytes[0] = bline[0];
		twobytes[1] = 0;
		j = toupper(twobytes[0]) - 'A';
		if (j >= 0 && j < 26)
			tmpdrive = j;
		else break;
		setdisk(tmpdrive);
		if (tmpdrive == getdisk()) {
			curdrive = tmpdrive;
			chdir(bline);
			}
		goto ReStart;
		}
	    break;

	// Benny's style
#ifdef LISTVERSION
	case 'o':
	case 'O':
#else
	case 'p':
	case 'P':
#endif
	    cprintf("Drive? ");
	    bline[0] = getch();
	    bline[1] = 0;
	    j = toupper(bline[0]) - 'A';
	    if (j >= 0 && j < 26)
		tmpdrive = j;
	    setdisk(tmpdrive);
	    if (tmpdrive == getdisk()) {
		curdrive = tmpdrive;
		goto ReStart;
	    }
	    break;

	case 'a':
	case 'A':
	    cprintf("Attribute? (+-ASHR) ");
	    BLINE;
	    if (blineflag) {
		cprintf("Attrib %s to %s ", logged[INDEX]->name, bline);
		CallCommands("ATTRIB", logged[INDEX]->name, bline);
		goto ReStart;
		}
	    break;
	case 'e':
//	case 'E':
//logged[INDEX]->LFN
	    if (iswin95 && logged[INDEX]->LFN[0])
		{
//		strcpy(logname, "\"\0");
//		strcat(logname, logged[INDEX]->LFN);
//		strcat(logname, "\"\0");
		strcpy(logname, logged[INDEX]->LFN);
		}
	    else
		strcpy(logname, logged[INDEX]->name);
	    FreeSpace();
	    CURSOR;
	    printf(PROGRAM0" '%s'     ", logname);
	    sprintf(call_list,"CALL %s%s", listpath, PROGRAM0);
	    CallCommand(call_list, logname);
	    NOCURSOR;
	    goto ReStart;
	case 'E':
	    strcpy(logname, logged[INDEX]->name);
	    FreeSpace();
	    CURSOR;
            printf(PROGRAM0" '%s'     ", logname);
	    sprintf(call_list,"CALL %s%s", listpath, PROGRAM0);
            CallCommand(call_list, logname);
	    NOCURSOR;
	    goto ReStart;
	case 'w':
	case 'W':
	    strcpy(logname, logged[INDEX]->name);
	    FreeSpace();
	    CURSOR;
	    sprintf(call_list,"CALL %s%s", listpath, PROGRAM4);
	    CallCommand(call_list, logname);
	    NOCURSOR;
	    goto ReStart;
	case 'g':
	case 'G':
	    strcpy(logname, logged[INDEX]->name);
	    FreeSpace();
	    CURSOR;
	    sprintf(call_list,"CALL %s%s", listpath, PROGRAM1);
            CallCommand(call_list, logname);

	    NOCURSOR;
	    goto ReStart;

	case 'm':
	case 'M':
	    cprintf("Move %s to?     ", logged[INDEX]->name);
	    BLINE;
	    if (blineflag) {
		cprintf("Moving %s to %s ", logged[INDEX]->name, bline);
		CallCommands("MOVE", logged[INDEX]->name, bline);
		goto ReStart;
		}
	    break;
	case 'r':
	case 'R':
	    char *tempname = logged[INDEX]->name;
	    if (tempname[0] == UPMARK)
		tempname++; // added, June
	    else if (tempname[0] == DOWNMARK)
		tempname++;
	    cprintf("Rename %s to?   ", tempname);
	    BLINE;
	    if (blineflag) {
		cprintf("Renaming %s to %s ", tempname, bline);
		CallCommands("REN", tempname, bline);
		goto ReStart;
		}
	    break;
	case 'v':
	case 'V':
	    CURSOR;
	    BODYCOLOR;
            cprintf(PROGRAM2" %s       \n\r", logged[INDEX]->name);
	    sprintf(call_list, "%s%s", listpath, PROGRAM2);
            spawnl(P_WAIT, call_list, call_list, logged[INDEX]->name, NULL);

	    getch();
	    NOCURSOR;
	    goto NextPage;
	case 'z':
	case 'Z':
	    CURSOR;

            cprintf(PROGRAM3 " %s       ", logged[INDEX]->name);
	    sprintf(call_list, "%s%s", listpath, PROGRAM3);
            spawnl(P_WAIT, call_list, call_list, logged[INDEX]->name, NULL);
	    NOCURSOR;
	    goto NextPage;
	case 's':
	case 'S':
	    cprintf("Sort by Date, Name, Ext, Size?", SortType);
	    bline[0] = getch();
	    bline[1] = 0;
	    blineval = bline[0] - '0';
	    switch (bline[0]) {
	    case 'd':
	    case 'D':
		SortType = BYDATE;
		goto ReSort;
	    case 'n':
	    case 'N':
	    case 'f': // for "filename"
	    case 'F':
		SortType = BYNAME;
		goto ReSort;
	    case 'e':
	    case 'E':
		SortType = BYEXT;
		goto ReSort;
	    case 's':
	    case 'S':
		SortType = BYSIZE;
		goto ReSort;
	    }
	    if (blineval == BYDATE ||
		blineval == BYNAME ||
		blineval == BYEXT ||
		blineval == BYSIZE
		) {
		SortType = blineval;
		goto ReSort;
	    }
	    REFRESH
	    break;
	case '*':
	    goto ReStart;
/*
        // todo
        case 'i':
	case 'I':
	    cprintf("Options? ");
	    BLINE;
	    break;
	case 'f':
	case 'F':
	    cprintf("filemask: %s ", filemask);
	    BLINE;
	    break;
*/
	case TAB:
	    sizemode = !sizemode;
	    goto ReStart;
	case '2':
	    FlagAttr = YES;
	    goto NextPage;
	case '1':
	    FlagAttr = NO;
	    goto NextPage;
	case '0':
	    break;
	case 'd':
	case 'D':
		//if (key == 0)
		{
		    char *tempname = logged[INDEX]->name;
		    if (tempname[0] == UPMARK) {
			tempname++; // added, June 1
			cprintf("Deleting '%s' \n\r", tempname);
			CallCommand(DELTREE, tempname);
//			rmdir(tempname);
			}
		    else if (tempname[0] == DOWNMARK) {
			tempname++;
			cprintf("Deleting '%s' \n\r", tempname);
			CallCommand(DELTREE, tempname);
//			rmdir(tempname);
			}
/*		    else {
			cprintf("Deleting '%s' ", tempname);
			CallCommand("DEL", tempname);
			}*/
		    goto ReStart;
		}
//		break;

	    //-----------------------------------------
	default:
	    switch (scan) {
            case F1: // (Benny)
		//textattr(1);
		textattr(LIGHTCYAN + (BLUE << 4));
		clrscr();
		puts(" ============ LISTy "VERSION" [Benny_land@geocities.com] =======");
		puts("");
		puts(" *:         Refresh list");
		puts(" 1 or 2:    Toggle display of attrib");
		puts(" A:         Change file attrib");
		puts(" BackSpace: Up one dir");
		puts(" C:         Copy this file");
		puts(" Ctrl-End   Last line  (same as Ctrl-PgDn)");
		puts(" Ctrl-Up    First line (same as Ctrl-PgUp)");
		puts(" D:         DelTree (with confirmation)");
		puts(" Del:       Delete file or empty dir (no ask)");
		puts(" Esc:       Go back to starting dir");
		puts(" F10:       LFN mode");
//		puts(" F9:        Free internal memory"); //debug
		puts(" M:         Move selected file");
#ifdef LISTVERSION
		puts(" P:         Change drive (path)");
		puts(" O:         Change drive (1 letter)");
#else
		puts(" O:         Change drive (path)");
		puts(" P:         Change drive (1 letter)");
#endif
		puts(" S:         Change Sort order");
		puts(" X:         Exit in this dir");
		puts("");
//		textattr(LIGHTCYAN + BLACK << 4);

		printf(" e/E:       Call %s%s [LFN/dos name]\n",listpath,PROGRAM0);
		printf(" G:         Call %s%s\n", listpath, PROGRAM1);
		printf(" V:         Call %s%s\n", listpath, PROGRAM2);
		printf(" W:         Call %s%s\n", listpath, PROGRAM4);
		printf(" Z:         Call %s%s\n", listpath, PROGRAM3);

		printf("Press a key");
		getch();
		goto ReStart;
	    case F10:
		    if (!iswin95) {
			usedos = !usedos;
			usedoslfn = !usedoslfn;
			goto ReStart;
		    }
		break;
	    case F9:
		FreeSpace();
		goto ReStart;
	    case UP:
		if (ypos > 2)
		    ypos--;
		else {
		    start--;
		    if (start < 0)
			start = 0;
		    goto NextPage;
		}
		break;
	    case DOWN:
		if (INDEX < ctl && ypos < 24)
		    ypos++;
		else if (start + 22 < ctl) {
		    start++;
		    if (INDEX > ctl)
			ypos = ctl - 2 - start;
		    goto NextPage;
		}
		break;
	    case END:
		if (ctl + 2 - start > 24)
		    ypos = 24;
		else
		    ypos = ctl + 2 - start;
		break;
	    case HOME:
		ypos = 2;
		break;
	    case DEL:
		if (key == 0) {
		    char *tempname = logged[INDEX]->name;
		    if (tempname[0] == UPMARK) {
			tempname++; // added, June 1
			cprintf("Deleting '%s' \n\r", tempname);
//			CallCommand("DELTREE /Y", tempname);
			rmdir(tempname);
			}
		    else if (tempname[0] == DOWNMARK) {
			tempname++;
			cprintf("Deleting '%s' \n\r", tempname);
//			CallCommand("DELTREE /Y", tempname);
			rmdir(tempname);
			}
		    else {
			cprintf("Deleting '%s' ", tempname);
			CallCommand("DEL", tempname);
			}
		    goto ReStart;
		}
		break;

	    case BACKSPACE:
	    case 0xE:
		chdir("..");
#ifdef DEBUG0
		printf("back= '..'\n");
#endif
		if (lastdir) {
		    start = laststart;
		    ypos = lastypos;
		    goto ReStart;
		}
		goto FullStart;
	    case CTRLEND:
	    case CTRLPGDN:
		ypos = 2;
		if (ctl > 22)
		    start = ctl - 22;
		else
		    start = ctl;
		if (ctl + 2 - start > 24)
		    ypos = 24;
		else
		    ypos = ctl + 2 - start;
		goto NextPage;
	    case PGDN:
		if (start < ctl - 22) {
		    start += 23;
		    if (INDEX > ctl)
			ypos = ctl + 2 - start;
		} else {
		    if (ctl + 2 - start > 24)
			ypos = 24;
		    else
			ypos = ctl + 2 - start;
		}
		goto NextPage;
	    case CTRLHOME:
	    case CTRLPGUP:
		ypos = 2;
		start = 0;
		goto NextPage;
	    case PGUP:
		if (start == 0 && ypos != 2) {
		    ypos = 2;
		    goto NextPage;
		} else {
		    start -= 23;
		    if (start < 0)
			start = 0;
		    goto NextPage;
		}
	    default:
		hit = 0;
	    }
	}
    }
}

main(int argc, char **argv)
{
    char far       *savescreen;
    int             j, tmpdrive;

    oldcursx = wherex();
    oldcursy = wherey();
    RestoreScreen = YES;
    savescreen = (char *) malloc(4000);
    if (!savescreen)
	RestoreScreen = NO;
    else
	memcpy(savescreen, (char *) TEXTLOCATION, 4000);

    // save original drive
    curdrive = startdrive = getdisk();
    current_directory(startdir);

    if (argc > 1) {
	j = toupper(argv[1][0]) - 'A';
	if (j >= 0 && j < 26 && argv[1][0] != '\\') {
	    tmpdrive = j;
	    setdisk(tmpdrive);
	    if (tmpdrive == getdisk()) {
		curdrive = tmpdrive;
	    }
	}
	if (chdir(argv[1]) == 0) {
#ifdef DEBUG0
	    printf("argv1= '%s'\n",argv[1]);
#endif
	    strcpy(curdir, argv[1]);
	}
    }
    GetSpecialsPath();
#ifdef DEBUG1
    printf("listpath = '%s'\n",listpath);
#endif

    MainRoutine();

    CURSOR;
    chdir(startdir);
#ifdef DEBUG0
    printf("startdir= '%s'\n",startdir);
#endif

    if (startdrive != curdrive)
	setdisk(startdrive);
    RESETCOLOR;
    gotoxy(1, 25);
    cprintf("\r ");
    for (j = 0; j < 80; j++)	cprintf(" ");
    cprintf("\r");
    gotoxy(1, 24);
//    cprintf("\r\n");

    if (RestoreScreen == YES) {
	memcpy((char *) TEXTLOCATION, savescreen, 4000);
	gotoxy(oldcursx, oldcursy);
	free(savescreen);
    }
    cprintf("LISTy [Build "__DATE__" "__TIME__"]");
//    cprintf("\r\n");
    return 0;
}
/* end */
